-- Midnight Reveries Naxxramas Boss Mods v7.13 - 25/08/2006
-- Updated sound events.

-- Loading Modules
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_MRRazuvious_OnLoad");
tinsert(CT_RABoss_ModsToLoad, "CT_RABoss_MRGothik_OnLoad");


-- Instructor Razuvious (19/08/2006) - Changed naming.
function CT_RABoss_MRRazuvious_OnLoad()
	CT_RABoss_AddMod("Deathknight wing: Instructor Razuvious", CT_RABOSS_MRRAZUVIOUS_INFO, 1, CT_RABOSS_LOCATIONS_MRNAXXRAMAS);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_MONSTER_YELL", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS", CT_RABoss_MRRazuvious_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Instructor Razuvious", "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS", CT_RABoss_MRRazuvious_EventHandler);

	CT_RABoss_AddDropDownButton("Deathknight wing: Instructor Razuvious", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_MRRazuvious_EventHandler(event)
	if ( not CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"] or not CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["status"] or not CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( arg1 == CT_RABOSS_MRRAZUVIOUS_YELL1 or arg1 == CT_RABOSS_MRRAZUVIOUS_YELL2 or arg1 == CT_RABOSS_MRRAZUVIOUS_YELL3 or arg1 == CT_RABOSS_MRRAZUVIOUS_YELL4 ) then
			CT_RABoss_Announce(CT_RABOSS_MRRAZUVIOUS_ENGAGED, CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_UnSchedule("CT_RABoss_MRRazuvious_EventHandler");
			CT_RABoss_Schedule("CT_RABoss_MRRazuvious_EventHandler", 15.5, "warn10");
			CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "25.5", CT_RABOSS_MRRAZUVIOUS_SHOUT, "25.5", "255*0*0"));
			end

		elseif ( arg1 == CT_RABOSS_MRRAZUVIOUS_DEAD_YELL1 ) then
			CT_RABoss_UnSchedule("CT_RABoss_MRRazuvious_EventHandler");
		end

	elseif ( event == "CHAT_MSG_SPELL_CREATURE_VS_SELF_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" or event == "CHAT_MSG_SPELL_CREATURE_VS_PARTY_DAMAGE" ) then
		if ( string.find(arg1, CT_RABOSS_MRRAZUVIOUS_SHOUT) and not CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["shouttrip"] ) then
			CT_RABoss_UnSchedule("CT_RABoss_MRRazuvious_EventHandler");
			CT_RABoss_Schedule("CT_RABoss_MRRazuvious_EventHandler", 15.5, "warn10");
			CT_RABoss_Schedule("CT_RABoss_MRRazuvious_EventHandler", 5, "preshout");
			CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["shouttrip"] = true;
			CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["lastaction"] = time();

			if ( not CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["shoutwarn"] ) then
				CT_RABoss_Announce(CT_RABOSS_MRRAZUVIOUS_SHOUTNEXT, CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"]);
				CT_RABoss_PlaySound(2);
			end

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "25.5", CT_RABOSS_MRRAZUVIOUS_SHOUT, "25.5", "255*0*0"));
			end
		end

	elseif ( event == "CHAT_MSG_COMBAT_CREATURE_VS_CREATURE_HITS" or event == "CHAT_MSG_COMBAT_CREATURE_VS_PARTY_HITS" or event == "CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS" ) then
		if ( string.find(arg1, CT_RABOSS_MRRAZUVIOUS_BOSSNAME) or string.find(arg1, CT_RABOSS_MRRAZUVIOUS_STUDENT) ) then
			CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["lastaction"] = time();
		end	

	elseif ( event == "preshout" ) then
		CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["shouttrip"] = false;

	elseif ( event == "warn10" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRRAZUVIOUS_SHOUTWARN, "10"), CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_MRRazuvious_EventHandler", 5, "warn5");
		CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["shoutwarn"] = false;

	elseif ( event == "warn5" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRRAZUVIOUS_SHOUTWARN, "5"), CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_MRRazuvious_EventHandler", 2, "warn3");

	elseif ( event == "warn3" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRRAZUVIOUS_SHOUTWARN, "3"), CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_MRRazuvious_EventHandler", 3, "shoutcast");

	elseif ( event == "shoutcast" ) then
		if ( not CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["lastaction"] or ( time() - CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["lastaction"] ) > 30 ) then
			return;
		else
			CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["shoutwarn"] = true;
			CT_RABoss_Announce(CT_RABOSS_MRRAZUVIOUS_SHOUTNEXT, CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Schedule("CT_RABoss_MRRazuvious_EventHandler", 15, "warn10");

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Instructor Razuvious"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "25", CT_RABOSS_MRRAZUVIOUS_SHOUT, "25", "255*0*0"));
			end
		end
	end
end


-- Gothik the Harvester (19/08/2006) - Changed naming.
function CT_RABoss_MRGothik_OnLoad()
	CT_RABoss_AddMod("Deathknight wing: Gothik the Harvester", CT_RABOSS_MRGOTHIK_INFO, 1, CT_RABOSS_LOCATIONS_MRNAXXRAMAS);
	CT_RABoss_AddEvent("Deathknight wing: Gothik the Harvester", "CHAT_MSG_MONSTER_YELL", CT_RABoss_MRGothik_EventHandler);
	CT_RABoss_AddEvent("Deathknight wing: Gothik the Harvester", "CHAT_MSG_COMBAT_HOSTILE_DEATH", CT_RABoss_MRGothik_EventHandler);

	CT_RABoss_AddDropDownButton("Deathknight wing: Gothik the Harvester", { CT_RABOSS_ANNOUNCE, CT_RABOSS_ANNOUNCE_INFO .. CT_RABOSS_REQ_LEADER_OR_PROM }, "CT_RABoss_ModInfo", "announce", "CT_RABoss_SetInfo");
end

function CT_RABoss_MRGothik_EventHandler(event)
	if ( not CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"] or not CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["status"] or not CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"].enabled ) then
		return;
	end

	if ( event == "CHAT_MSG_MONSTER_YELL" ) then
		if ( string.find(arg1, CT_RABOSS_MRGOTHIK_PHASE1_YELL1) ) then
			CT_RABoss_Announce(CT_RABOSS_MRGOTHIK_ENGAGED, CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
			CT_RABoss_PlaySound(3);
			CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 34, "inctimer");
			CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 24, "inctrainee");
			CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 74, "incknight");
			CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 134, "incrider");
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["timeleft"] = 4;
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["stoptimer"] = false;
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["lastaction"] = time();

			if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"] ) then
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MRGOTHIK_TRAINEES, "20", "0*255*0"));
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "20", CT_RABOSS_MRGOTHIK_KNIGHTS, "70", "0*0*255"));
				CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "3", "20", CT_RABOSS_MRGOTHIK_RIDERS, "130", "255*0*0"));
			end

		elseif ( arg1 == CT_RABOSS_MRGOTHIK_PHASE2_YELL1 ) then
			CT_RABoss_Announce(CT_RABOSS_MRGOTHIK_INC, CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
			CT_RABoss_PlaySound(2);
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["stoptimer"] = true;
		end
	
	elseif ( event == "CHAT_MSG_COMBAT_HOSTILE_DEATH" ) then
		if ( string.find(arg1, CT_RABOSS_MRGOTHIK_TRAINEE) ) then
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["lastaction"] = time();

		elseif ( string.find(arg1, CT_RABOSS_MRGOTHIK_KNIGHT) ) then
			CT_RABoss_Announce(CT_RABOSS_MRGOTHIK_KNIGHT_DEAD, CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["lastaction"] = time();

		elseif ( string.find(arg1, CT_RABOSS_MRGOTHIK_RIDER) ) then
			CT_RABoss_Announce(CT_RABOSS_MRGOTHIK_RIDER_DEAD, CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["lastaction"] = time();
		end

	elseif ( event == "inctimer") then
		if ( not CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["lastaction"] or ( time() - CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["lastaction"] ) > 45 ) then
			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["stoptimer"] = true;

		elseif ( CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["timeleft"] == 0.5 ) then
			CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 20, "inc10");
			CT_RABoss_Announce(format(CT_RABOSS_MRGOTHIK_SECWARN, "30"), CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
			CT_RABoss_PlaySound(3);
		else
			if ( CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["timeleft"] == 1 ) then
				CT_RABoss_Announce(CT_RABOSS_MRGOTHIK_1MINWARN, CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
			else
				CT_RABoss_Announce(format(CT_RABOSS_MRGOTHIK_WARN, CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["timeleft"]), CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
			end

			CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["timeleft"] = CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["timeleft"]-0.5;
			CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 30, "inctimer");
			CT_RABoss_PlaySound(3);
		end

	elseif ( event == "inctrainee" and not CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["stoptimer"] ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRGOTHIK_ADD_INC, CT_RABOSS_MRGOTHIK_TRAINEES), CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 20, "inctrainee");

		if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"] ) then
			CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "1", "20", CT_RABOSS_MRGOTHIK_TRAINEES, "20", "0*255*0"));
		end

	elseif ( event == "incknight" and not CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["stoptimer"] ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRGOTHIK_ADD_INC, CT_RABOSS_MRGOTHIK_KNIGHTS), CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 25, "incknight");

		if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"] ) then
			CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "2", "25", CT_RABOSS_MRGOTHIK_KNIGHTS, "25", "0*0*255"));
		end

	elseif ( event == "incrider" and not CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["stoptimer"] ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRGOTHIK_ADD_INC, CT_RABOSS_MRGOTHIK_RIDERS), CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
		CT_RABoss_PlaySound(3);
		CT_RABoss_Schedule("CT_RABoss_MRGothik_EventHandler", 30, "incrider");

		if ( CT_RA_Level >= 1 and CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"] ) then
			CT_RA_SendMessage(format(CT_RABOSS_MRMUKKA_STRING, "3", "30", CT_RABOSS_MRGOTHIK_RIDERS, "30", "255*0*0"));
		end

	elseif ( event == "inc10" ) then
		CT_RABoss_Announce(format(CT_RABOSS_MRGOTHIK_SECWARN, "10"), CT_RABoss_Mods["Deathknight wing: Gothik the Harvester"]["announce"]);
		CT_RABoss_PlaySound(3);

	end
end